// Sample class that implements Comparable interface
class Person implements Comparable<Person>{
  String first,last;
  public Person(String first, String last){
    this.first=first; this.last=last;
  }
  public String toString(){
    return String.format("%s %s",first,last);
  }

  public boolean equals(Object o){
    if(o==null || !(o instanceof Person)){
      return false;
    }
    Person that = (Person) o;
    return this.last.equals(that.last) && this.first.equals(that.first);
  }
      
  public int compareTo(Person other){
    int result = this.last.compareTo(other.last);
    if(result != 0){
      return result;
    }
    return this.first.compareTo(other.first);
  }
}

// Demonstrations of binary search
public class GeneralizedBinarySearch{
  // Use binary search to locate integer key in array a
  public static <T extends Comparable<T>>
  int binarySearch(T a[], T key){
    int left=0, right=a.length-1;
    int mid = 0;
    while(left <= right){
      mid = (left+right)/2;
      if(key.compareTo(a[mid])==0){
	return mid;
      }else if(key.compareTo(a[mid]) < 0){
	right = mid-1;
      }
      else{
	left = mid+1;
      }
    }
    return -1;
  }

  public static void main(String args[]){
    String [] arr = {"A","B","E","G","H","K","M","T","V"};
    //                0   1   2   3   4   5   6   7   8
    System.out.println(java.util.Arrays.toString(arr));

    // Works for Strings
    System.out.println( "A: " + binarySearch( arr,"A") );
    System.out.println( "C: " + binarySearch( arr,"C") );
    System.out.println( "L: " + binarySearch( arr,"L") );
    System.out.println( "K: " + binarySearch( arr,"K") );
    System.out.println( "U: " + binarySearch( arr,"U") );
    System.out.println( "V: " + binarySearch( arr,"V") );
    System.out.println( "Z: " + binarySearch( arr,"Z") );

    Person [] ppl = {
      new Person("Jack"   ,"Harkness"),
      new Person("Martha" ,"Jones"),
      new Person("Donna"  ,"Noble"),
      new Person("Mickey" ,"Smith"),
      new Person("Rose"   ,"Tyler"),
    };

    
    System.out.println(java.util.Arrays.toString(ppl));
    Person key;
    key = new Person("Martha","Jones");
    System.out.println( key +": "+ binarySearch(ppl,key));
    key = new Person("Amy","Pond");
    System.out.println( key +": "+ binarySearch(ppl,key));
  }


}
